#ifndef slidingConesFvMesh_H
#define slidingConesFvMesh_H
#include "topoChangerFvMesh.H"
#include "motionSolver.H"
namespace Foam
{
class slidingConesFvMesh:public topoChangerFvMesh
{
    // Private data
        //- Motion dictionary
        dictionary motionDict_;
        //- Motion velocity amplitude
        vector motionVelAmplitude_;
        //- Motion velocity period
        scalar motionVelPeriod_;
        //- Motion velocity period Totally unnecessary, added by some previous programmer /R33K
        //vector curMotionVel_;
        //- Left edge
        scalar leftEdge_;
        //- Current left obstacle position
        scalar curLeft_;
        //- Current right obstacle position
        scalar curRight_;
        //- Current left Upper obstacle position
        scalar curLeftUpper_;
        //- Current right Upper obstacle position
        scalar curRightUpper_;
        //- Vertex motion mask
        scalarField motionMask_;
    // Private Member Functions
        //- Disallow default bitwise copy construct
        slidingConesFvMesh(const slidingConesFvMesh&);
        //- Disallow default bitwise assignment
        void operator=(const slidingConesFvMesh&);
        //- Add mixer zones and modifiers
        void addZonesAndModifiers();
        //- Markup motion vertices
        tmp<scalarField> vertexMarkup
        (
            const pointField& p,
            const scalar& curLeft,
            const scalar& curRight,
            const scalar& curLeftUpper,
            const scalar& curRightUpper
        ) const;
public:
    //- Runtime type information
    TypeName("slidingConesFvMesh");
    // Constructors
        //- Construct from database
        explicit slidingConesFvMesh(const IOobject& io);
    // Destructor
        virtual ~slidingConesFvMesh();
    // Member Functions
        //- Update the mesh for both mesh motion and topology change
        virtual bool update();
};
} // End namespace Foam
#endif
